﻿using System;
using System.ComponentModel;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;

namespace SWF_Download
{
    class Program
    {
        public int counter = 0;
        public static bool close = false;
        public static bool EntireGordan = false;
        public static bool upload;

        public static string release;
        public static string dir = "swfs/";

        static void Main(string[] args)
        {
            Console.Title = "SWF Downloader (10-12-2015)";

            try
            {
                //Directory.Delete(dir, true);
            }
            catch { }

            try
            {
                Directory.CreateDirectory(dir);
            }
            catch { }

            Console.WriteLine("init -> SWF downloader by Quackster");
            Console.WriteLine("init -> Finding release...");
            Console.WriteLine();

            HttpClient httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Add("User-Agent", "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.86 Safari/537.36");

            Program program = new Program();

            Task.Run(async () =>
            {
                try
                {
                    HttpResponseMessage res = await httpClient.GetAsync("https://www.habbo.com/gamedata/external_variables/1");
                    string source = (await res.Content.ReadAsStringAsync());

                    foreach (string Line in source.Split(Environment.NewLine.ToCharArray()))
                    {
                        if (!Line.Contains("flash.client.url="))
                        {
                            continue;
                        }

                        release = Line.Substring(0, Line.Length - 1).Split('/')[4];

                        Console.WriteLine("Found release: " + release);

                        if (!EntireGordan)
                        {
                            if (!File.Exists(dir + release + ".swf"))
                            {
                                Console.ForegroundColor = ConsoleColor.Green;
                                Console.WriteLine("New release, downloading!");
                                Console.WriteLine();
                                Console.ResetColor();

                                WebClient client = new WebClient();

                                string gordan = (Line.Replace("flash.client.url=", "")).Replace("//", "http://");
                                string swfUrl = (Line.Replace("flash.client.url=", "") + "Habbo.swf").Replace("//", "http://");

                                new DownloadFile(release + ".swf", swfUrl, dir, true);

                            }
                            else
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                Console.WriteLine("File exists, not downloading");
                                Console.ResetColor();

                                close = true;
                            }
                        }
                        else
                        {
                            string gordan = (Line.Replace("flash.client.url=", "")).Replace("//", "http://");

                            Console.ForegroundColor = ConsoleColor.DarkYellow;
                            Console.WriteLine();
                            Console.WriteLine("Downloading entire Gordan directory!");
                            Console.WriteLine();
                            Console.ResetColor();

                            Directory.CreateDirectory(dir + release);

                            GordanDownloader.Download(gordan, dir + release);
                        }

                    }
                }
                catch (Exception e)
                {
                    Console.WriteLine(e);
                }
            });

            while (!close)
            {
                if (upload)
                {
                    Console.WriteLine();
                    Console.WriteLine("Finished getting " + release + ".swf");
                    Console.WriteLine();

                    File.AppendAllText("swf_download_history.txt", release + ".swf" + Environment.NewLine);

                    upload = false;
                    Thread.Sleep(10 * 1000);
                    close = true;
                }
            };
        }

    }
}
